/*
 * LinRemote : a program to emulate Mindstorms Remote under linux
 * Copyright (C) 2003  nanobapt
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Special thanks to :
     * J1B : Make the debian package and have the text mode idea
     * Chris : to indicate me that message for remote control exist ...
     
 */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <string.h>
#include "gtk_mode.h"
#include "IO.h"
#include "text_mode.h"

int main(int argc, char *argv[] )
{
	int fd;
	
	fd = iTTY(); //init TTY "/dev/ttyS0 is the default
	
	if(argc > 1)
	{
		if(!strcmp(argv[1], (char*)"-t"))
		{
			t_mod(argc, argv, fd);
		}
	}
	else 
	{
 	   gtk_init (&argc, &argv); //gtk init
  	  cWin(fd); //create and display window
	}
    
    close(fd); //close TTY

    return EXIT_SUCCESS;
}