/*
 * Function to command the RCX
 */

#include <gtk/gtk.h>
#include <unistd.h>
#include "IO.h"
 
unsigned char alt=0x00;

void command(gpointer data, int fd)
{
	unsigned char code[10];
	
	if(alt == 0x00)
		alt=0x08;
	else
		alt=0x00;
		
	if(data == (gpointer)MESSAGE_1)
	{
		code[0]=0xF7+alt;
		code[1]=0x00;
		send(code, 2, fd);
	}
	else if(data == (gpointer)MESSAGE_2)
	{
		code[0]=0xF7+alt;
		code[1]=0x01;
		send(code, 2, fd);
	}
	else if(data == (gpointer)MESSAGE_3)
	{
		code[0]=0xF7+alt;
		code[1]=0x02;
		send(code, 2, fd);
	}
	else if(data == (gpointer)FWD_A)
	{
		code[0]=0xE1+alt;
		code[1]=0x81;
		send(code, 2, fd);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x81;
		send(code, 2, fd);
	}
	else if(data == (gpointer)FWD_B)
	{
		code[0]=0xE1+alt;
		code[1]=0x82;
		send(code, 2, fd);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x82;
		send(code, 2, fd);
	}
	else if(data == (gpointer)FWD_C)
	{
		code[0]=0xE1+alt;
		code[1]=0x84;
		send(code, 2, fd);
		usleep(100000);
		code[0]=0x21+alt;
		code[1]=0x84;
		send(code, 2, fd);
	}
	else if(data == (gpointer)REV_A)
	{
		code[0]=0xE1+alt;
		code[1]=0x81;
		send(code, 2, fd);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x41;
		send(code, 2, fd);
		usleep(100000);
			
		code[0]=0x21+alt;
		code[1]=0x81;
		send(code, 2, fd);		
	}
	else if(data == (gpointer)REV_B)
	{
		code[0]=0xE1+alt;
		code[1]=0x82;
		send(code, 2, fd);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x42;
		send(code, 2, fd);
		usleep(100000);
		
		code[0]=0x21+alt;
		code[1]=0x82;
		send(code, 2, fd);
	}
	else if(data == (gpointer)REV_C)
	{
		code[0]=0xE1+alt;
		code[1]=0x84;
		send(code, 2, fd);
		usleep(100000);

		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;

		code[0]=0xE1+alt;
		code[1]=0x44;
		send(code, 2, fd);
		usleep(100000);

		code[0]=0x21+alt;
		code[1]=0x84;
		send(code, 2, fd);
	}
	else if(data == (gpointer)STOP)
	{
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
			
		code[0]=0x21+alt;
		code[1]=0x41;
		send(code, 2, fd);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
			
		code[0]=0x21+alt;
		code[1]=0x42;
		send(code, 2, fd);
		usleep(100000);
		
		if(alt == 0x00)
			alt=0x08;
		else
			alt=0x00;
		
		code[0]=0x21+alt;
		code[1]=0x44;
		send(code, 2, fd);
	}
	else if(data == (gpointer)BEEP)
	{
		code[0]=0x51+alt;
		code[1]=0x00;
		send(code, 2, fd);
	}
	else if(data == (gpointer)P1)
	{
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x02;
		code[2]=0x00;
		send(code, 3, fd);
	}
	else if(data == (gpointer)P2)
	{
		code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);code[0]=0xD2;
		code[1]=0x04;
		code[2]=0x00;
		send(code, 3, fd);
	}
	else if(data == (gpointer)P3)
	{
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x08;
		code[2]=0x00;
		send(code, 3, fd);
	}
	else if(data == (gpointer)P4)
	{
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x10;
		code[2]=0x00;
		send(code, 3, fd);
	}
	else if(data == (gpointer)P5)
	{
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd);
		usleep(100000);
		code[0]=0xD2;
		code[1]=0x20;
		code[2]=0x00;
		send(code, 3, fd);
	}	
	else if(data == (gpointer)STOP_A)
	{
		code[0]=0x21+alt;
		code[1]=0x41;
		send(code, 2, fd);
	}
	else if(data == (gpointer)STOP_B)
	{
		code[0]=0x21+alt;
		code[1]=0x42;
		send(code, 2, fd);
	}
	else if(data == (gpointer)STOP_C)
	{
		code[0]=0x21+alt;
		code[1]=0x44;
		send(code, 2, fd);
	}
}