/* 
 * Text mode function
 */
 
#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include "IO.h"
#include "rcx_com.h"

void t_mod(int argc, char *argv[], int fd)
{
	int i;
	
	printf("Text mode ON\n");
	
	for(i=0; i<(argc-2); i++)
	{
		//printf("argument %d -> %s\n", i, argv[i+2]);
		
		// On motor FWD
		if(!strcmp((char *)"ON_FWD", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"A", argv[i+2]))
				command((gpointer)FWD_A, fd);
			else if(!strcmp((char *)"B", argv[i+2]))
				command((gpointer)FWD_B, fd);
			else if(!strcmp((char *)"C", argv[i+2]))
				command((gpointer)FWD_C, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// On motor REV
		else if(!strcmp((char *)"ON_REV", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"A", argv[i+2]))
				command((gpointer)REV_A, fd);
			else if(!strcmp((char *)"B", argv[i+2]))
				command((gpointer)REV_B, fd);
			else if(!strcmp((char *)"C", argv[i+2]))
				command((gpointer)REV_C, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// STOP motor
		else if(!strcmp((char *)"STOP", argv[i+2]))
		{
			if(argc-3 != i)
			{
				i++;
				if(!strcmp((char *)"A", argv[i+2]))
					command((gpointer)STOP_A, fd);
				else if(!strcmp((char *)"B", argv[i+2]))
					command((gpointer)STOP_B, fd);
				else if(!strcmp((char *)"C", argv[i+2]))
					command((gpointer)STOP_C, fd);
				else 
				{
					printf("Error syntax near -> \"%s\"\n", argv[i+2]);
					exit(1);
				}
			}
			else
			{
				command((gpointer)STOP, fd);
			}
		}
		else if(!strcmp((char *)"MSG", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"1", argv[i+2]))
				command((gpointer)MESSAGE_1, fd);
			else if(!strcmp((char *)"2", argv[i+2]))
				command((gpointer)MESSAGE_2, fd);
			else if(!strcmp((char *)"3", argv[i+2]))
				command((gpointer)MESSAGE_3, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		// Run program
		else if(!strcmp((char *)"PGM", argv[i+2]))
		{
			if(argc-3 != i)
				i++;
			else
			{
				printf("Need argument for \"%s\"\n", argv[i+2]);
				exit(1);
			}
				
			if(!strcmp((char *)"1", argv[i+2]))
				command((gpointer)P1, fd);
			else if(!strcmp((char *)"2", argv[i+2]))
				command((gpointer)P2, fd);
			else if(!strcmp((char *)"3", argv[i+2]))
				command((gpointer)P3, fd);
			else if(!strcmp((char *)"4", argv[i+2]))
				command((gpointer)P4, fd);
			else if(!strcmp((char *)"5", argv[i+2]))
				command((gpointer)P5, fd);
			else 
			{
				printf("Error syntax near -> \"%s\"\n", argv[i+2]);
				exit(1);
			}
		}
		
		
				
		else
		{
			printf("Error syntax near -> \"%s\"\n", argv[i+2]);
			exit(1);
		}
	usleep(100000);
	}
}
